import java.util.HashMap;
import java.util.Map;

import org.codehaus.jackson.map.ObjectMapper;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientConsumer;
import org.hornetq.api.core.client.ClientMessage;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.ServerLocator;
import org.hornetq.core.remoting.impl.invm.InVMConnectorFactory;
import org.hornetq.core.remoting.impl.netty.NettyConnectorFactory;


public class hqtestclient {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		ClientMessage msg = null;
		ClientSession session = null;
		ClientConsumer messageConsumer = null;
		final String queueName = "queue.exampleQueue";

        HashMap<String, Object> map = new HashMap<String, Object>();
        map.put("host", "192.168.20.150");
        map.put("port", 8989);
		
		try {
	        
	        /*
	        // moved to while loop
	        ServerLocator serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(NettyConnectorFactory.class.getName(),map));
	        //ServerLocator serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(InVMConnectorFactory.class.getName()));
	        serverLocator.setConnectionTTL(-1);
	        serverLocator.setClientFailureCheckPeriod(-1);
	        ClientSessionFactory sf = serverLocator.createSessionFactory();
			
			session = sf.createSession();
            messageConsumer = session.createConsumer(queueName,"CCAgent = '70220'");
            session.start();
			*/
			while(true) {
	        	String Event_Name = "";
	        	String Event_Subclass = "";
	        	String CC_Agent = "";
	        	String CC_Action = "";
	        	Long Event_Timestamp = 0L;
	        	Long Event_Sequence = 0L;
	        	
		        ServerLocator serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(NettyConnectorFactory.class.getName(),map));
		        //ServerLocator serverLocator = HornetQClient.createServerLocatorWithoutHA(new TransportConfiguration(InVMConnectorFactory.class.getName()));
		        serverLocator.setConnectionTTL(-1);
		        serverLocator.setClientFailureCheckPeriod(-1);
		        ClientSessionFactory sf = serverLocator.createSessionFactory();
				
				session = sf.createSession();
	            messageConsumer = session.createConsumer(queueName,"CCAgent = '70220'");
	            session.start();
	        	
				msg = messageConsumer.receive();
				msg.acknowledge();
				byte[] m = (byte[]) msg.getBytesProperty("zmq");
				
				Map<String,Object> fsevent = getMessageMap(m);
	        	try {
	    			Event_Name = fsevent.get("Event-Name").toString();
	    			if(!Event_Name.equals("CUSTOM"))
	    				continue;
	    			
	    			Event_Subclass = fsevent.get("Event-Subclass").toString();
	    			if(!Event_Subclass.equals("callcenter::info"))
	    				continue;
	    			
	    			Event_Timestamp = Long.parseLong(fsevent.get("Event-Date-Timestamp").toString());
	    			Event_Sequence = Long.parseLong(fsevent.get("Event-Sequence").toString());
	    			CC_Agent = fsevent.get("CC-Agent").toString();
	    			CC_Action = fsevent.get("CC-Action").toString();
	    			
	        	} catch (NullPointerException e) {
	        		// ignore
	        	} catch (Exception e) {
	        		e.printStackTrace();
	        	}
	        	System.out.println("EVENT# "+Event_Sequence+" , NAME: "+Event_Name+" , TS: "+Event_Timestamp+" , AGENT: "+CC_Agent+" , ACTION: "+CC_Action);
	        	System.out.println("Event-Seq: "+msg.getLongProperty("EventSequence")+ " , "+msg.getStringProperty("CCAgent"));
	        	
				messageConsumer.close();
				session.close();
				sf.cleanup();
				sf.close();
				serverLocator.close();
			}				
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static Map<String,Object> getMessageMap(byte[] message)
	{
		try {
			ObjectMapper mapper = new ObjectMapper();
			@SuppressWarnings("unchecked")
			Map<String,Object> userData = mapper.readValue(message, Map.class);
			return userData;
		} catch (Exception e) {
			e.printStackTrace();	
        }
		return null;
	}

}
